Attribute VB_Name = "CadDe_TextCalculate"
Option Explicit

' Feletic 11.07.2002
Public Sub TextCalculate()
' Berechnungen mit Text (=Zahl), Nachkommastellen werden mit dem Eingabewert festgelegt
' Mgliche Operatoren: *, x, /, :, +, -
' Eingabebeispiele: *25.23, +10, /13.50, -33.333

    Dim SS As AcadSelectionSet
    Dim FltTypesT(0) As Integer
    Dim FltDataT(0) As Variant
    
    Dim Obj As AcadEntity
    Dim TextObj As AcadText
    
    Dim Wert1 As String
    Dim Wert2 As String
    Dim Operator As String
    
    Dim Prefix As String
    Dim Vorzeichen As String
    Dim Nachkomma As Long
    Dim Suffix As String
    
    Dim Wert1Z As Double
    Dim Wert2Z As Double
    
    Set SS = CreateSelectionSet("TextCalculateAuswahl")

    FltTypesT(0) = 0: FltDataT(0) = "TEXT"
    
    ' Selectionset erstellen, Benutzer fragen und Filter anwenden
    SS.SelectOnScreen FltTypesT, FltDataT
    
    If SS.Count = 0 Then GoTo ENDE
    
EINGABE_WERT2:
    On Error GoTo ENDE
    Wert2 = ThisDrawing.Utility.GetString(0, "Operator und Rechenwert (incl. Nachkommastellen) eingeben: ")
    
    Operator = Left(Wert2, 1)
    Select Case Format(Operator, ">")
        Case "X"
            Operator = "*"
        Case ":"
            Operator = "/"
        Case "+", "-", "*", "/"
        
        Case Else
            ' Kein Operator eingegeben
            GoTo EINGABE_WERT2
    End Select
    Wert2 = funKomma(Mid(Wert2, 2))
    
    For Each Obj In SS
        
        Set TextObj = Obj
        
        ZahlFinden TextObj.textString, Prefix, Vorzeichen, Wert1, Nachkomma, Suffix
        
        If Wert1 = "" Then GoTo NAECHSTES_OBJEKT
        
        Wert1 = Vorzeichen & funKomma(Wert1)
        
        Nachkomma = funStellenNachKomma(Wert2)
        
        Select Case Operator
            Case "*"
                TextObj.textString = Wert1 * Wert2
            Case "/"
                TextObj.textString = Wert1 / Wert2
            Case "+"
                Wert1Z = Wert1
                Wert2Z = Wert2
                TextObj.textString = Wert1Z + Wert2Z
            Case "-"
                TextObj.textString = Wert1 - Wert2
        End Select
        
        TextObj.textString = funPunkt(Format(TextObj.textString, IIf(Nachkomma = 0, "0", "0." & String(Nachkomma, "0"))))
        
        If Vorzeichen <> "" Then
            If Val(TextObj.textString) > 0 Then TextObj.textString = "+" & TextObj.textString
        End If
        
        TextObj.textString = Prefix & TextObj.textString & Suffix
        
NAECHSTES_OBJEKT:
    Next Obj
    
ENDE:
    SS.Delete

End Sub

' Funktion von der Homepage - http://code.acadx.com/
Public Function CreateSelectionSet(Optional ssName As String = "SS") As AcadSelectionSet
    
    Dim SS As AcadSelectionSet
    
    On Error Resume Next
    Set SS = ThisDrawing.SelectionSets(ssName)
    If Err Then Set SS = ThisDrawing.SelectionSets.Add(ssName)
    SS.Clear
    Set CreateSelectionSet = SS

End Function

' Ersetz Punkt durch Komma
Public Function funKomma(Wert)
    Dim Punkt As Long
    Dim Komma As Long
    
    Wert = LTrim(Wert)
    Punkt = InStr(Wert, ".")
    If Punkt > 0 Then Mid(Wert, Punkt) = ","
    Komma = InStr(Wert, ",")
    If Komma = 1 Then Wert = "0" & Wert
    
    funKomma = Wert
End Function

Public Sub ZahlFinden(Text, Prefix, Vorzeichen, Zahl, Nachkomma, Suffix)
' Sucht in einem String nach einem Teilstring, der eine Zahl reprsentiert (Format #.##)
' Der String wird in 4 Teile zerlegt: Prefix, Vorzeichen, Zahl, Suffix
' Erstellt: Tremel 18.02.2002


    Dim TextLen As Long       'Textlnge des gesamten Strings
    Dim ZahlTmp() As String   'Feld mit allen gefundenen Teilstrings, die als Zahl in Frage kommen
    Dim ZahlPos() As Long     'Startposition der Zahl im durchsuchten Text
    Dim ZahlLen() As Long     'Zeichenlnge der Zahl
    Dim ZahlTrz() As Long     'Anzahl der Trennzeichen innerhalb der Zahl
    Dim ZahlVor() As Long     'Anzahl der Vorkommastellen der Zahl
    Dim ZahlNach() As Long    'Anzahl der Nachkommastellen der Zahl
    Dim ZahlBew() As Integer  'Bewertet die gefundene Zahl
    Dim ZahlIndex As Long     'Index fr ZahlPos, ZahlLen, ZahlTrz, ...
    
    Dim MaxWert As Integer  'Hchste Bewertung fr eine Zahl
    Dim BesteIndex As Long  'Index der besten Zahl
    Dim Mehrfach As Boolean 'Wird "True", wenn es mehrere beste Zahlen gibt
    
    Dim Index1 As Long  'Zhler
    Dim Index2 As Long  'Zhler
    Dim Index3 As Long  'Zhler
    
    
    Prefix = ""
    Vorzeichen = ""
    Zahl = ""
    Nachkomma = 0
    Suffix = ""
    
    TextLen = Len(Text)
    ZahlIndex = 0
    
    
    'Der Text wird Zeichen fr Zeichen nach Zahlen dursucht.
    'Jeder Teilstring, der eine Zahl reprsentiert, wird separat in der Variable ZahlTmp(x) gespeichert:
    For Index1 = 1 To TextLen
    
        If Mid(Text, Index1, 1) Like "#" Then    ' Ziffer gefunden
        
            ZahlIndex = ZahlIndex + 1
            ReDim Preserve ZahlTmp(ZahlIndex)
            ReDim Preserve ZahlPos(ZahlIndex)
            ReDim Preserve ZahlLen(ZahlIndex)
            ReDim Preserve ZahlTrz(ZahlIndex)
            ReDim Preserve ZahlVor(ZahlIndex)
            ReDim Preserve ZahlNach(ZahlIndex)
            ReDim Preserve ZahlBew(ZahlIndex)
            ZahlTmp(ZahlIndex) = Mid(Text, Index1, 1)
            ZahlPos(ZahlIndex) = Index1
            ZahlLen(ZahlIndex) = 1
            ZahlVor(ZahlIndex) = 1
            ZahlTrz(ZahlIndex) = 0
            
            If Index1 < TextLen Then    'Noch nicht am Ende der Zeichenkette
            
                'Solange weitere Ziffern oder Trennzeichen folgen, wird die Zahl nach rechts verlngert:
                For Index2 = Index1 + 1 To TextLen
                    Select Case Mid(Text, Index2, 1)
                        Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
                            ZahlTmp(ZahlIndex) = ZahlTmp(ZahlIndex) & Mid(Text, Index2, 1)
                            ZahlLen(ZahlIndex) = ZahlLen(ZahlIndex) + 1
                            Select Case ZahlTrz(ZahlIndex)  'Anzahl der bisher gefundenen Trennzeichen
                                Case 0
                                    ZahlVor(ZahlIndex) = ZahlVor(ZahlIndex) + 1
                                Case 1
                                    ZahlNach(ZahlIndex) = ZahlNach(ZahlIndex) + 1
                            End Select
                        Case ".", ","
                            ZahlTmp(ZahlIndex) = ZahlTmp(ZahlIndex) & Mid(Text, Index2, 1)
                            ZahlLen(ZahlIndex) = ZahlLen(ZahlIndex) + 1
                            ZahlTrz(ZahlIndex) = ZahlTrz(ZahlIndex) + 1
                        Case Else
                            Index1 = Index1 + ZahlLen(ZahlIndex) - 1 'Text soll mit dem nchsten Zeichen nach der gefundenen Zahl weiter dursucht werden
                            Exit For
                    End Select
                    If Index2 = TextLen Then Index1 = TextLen
                Next Index2
                
                'Sollte das letzte Zeichen ein Beistrich sein, wird dieser gelscht:
                If Right(ZahlTmp(ZahlIndex), 1) = "," Then
                    ZahlLen(ZahlIndex) = ZahlLen(ZahlIndex) - 1
                    ZahlTrz(ZahlIndex) = ZahlTrz(ZahlIndex) - 1
                    ZahlTmp(ZahlIndex) = Left(ZahlTmp(ZahlIndex), ZahlLen(ZahlIndex))
                End If
                
            End If
        End If
    Next Index1
    
    
    'Alle gefundenen Zahlen bewerten:
    
    MaxWert = 0
    Mehrfach = False
    
    For Index3 = 1 To ZahlIndex
        Select Case ZahlTrz(Index3)
            Case 0  'Zahl ohne Trennzeichen (Komma)
                    Select Case ZahlLen(Index3)
                        Case 1      '1-stellig
                            ZahlBew(Index3) = 30
                        Case 2, 3   '2- oder 3-stellig
                            ZahlBew(Index3) = 50
                        Case Else   '4- oder mehrstellig
                            ZahlBew(Index3) = 40
                    End Select
            Case 1  'Zahl mit 1 Trennzeichen (Komma)
                    If ZahlNach(Index3) = 0 Then    'Zahl endet mit (genau) einem Punkt
                        ZahlBew(Index3) = 0
                    Else
                        Select Case ZahlVor(Index3) ^ 3 + ZahlNach(Index3) ^ 3
                            Case Is < 55    'Zahl hat 1-3 Vorkomma- und 1-3 Nachkommastellen
                                ZahlBew(Index3) = 100
                            Case Else       'Zahl hat mehr als 3 Vorkomma- oder Nachkommastellen
                                ZahlBew(Index3) = 90
                        End Select
                    End If
            Case Else  'Zahl mit 3 oder mehr Trennzeichen (Komma)
                ZahlBew(Index3) = 0     'scheidet aus
        End Select
        
        'Von allen gefunden Zahlen die "beste" ausgewhlen:
        Select Case ZahlBew(Index3)
            Case Is > MaxWert
                BesteIndex = Index3
                MaxWert = ZahlBew(Index3)
            Case MaxWert
                BesteIndex = 0
        End Select
        
    Next Index3
    

    ' Variablen zuweisen:
    If BesteIndex <> 0 Then
    
        Zahl = ZahlTmp(BesteIndex)
        Nachkomma = ZahlNach(BesteIndex)
        
        'Vorzeichen:
        If ZahlPos(BesteIndex) > 1 Then
            Select Case Mid(Text, ZahlPos(BesteIndex) - 1, 1)
                Case "+", "-", ""
                    Vorzeichen = Mid(Text, ZahlPos(BesteIndex) - 1, 1)
            End Select
        End If
        
        Prefix = Left(Text, ZahlPos(BesteIndex) - 1 - Len(Vorzeichen))
        Suffix = Right(Text, TextLen - ZahlPos(BesteIndex) - ZahlLen(BesteIndex) + 1)
        
    End If
    
End Sub

' Ermittelt Stellen vor Komma
' Der bergebene Wert mu ein "," als Kommastelle beinhalten
Public Function funStellenNachKomma(Wert)
    Dim Komma As Long
    
    Komma = InStr(Wert, ",")
        
    Select Case Komma
        Case 0
            funStellenNachKomma = 0
        Case Else
            funStellenNachKomma = Len(Wert) - InStr(Wert, ",")
    End Select
    
End Function

'Ersetzt Komma durch Punkt
Public Function funPunkt(Wert)
    Dim Punkt As Long
    Dim Komma As Long
    
    Wert = LTrim(Wert)
    Komma = InStr(Wert, ",")
    If Komma > 0 Then Mid(Wert, Komma) = "."
    Punkt = InStr(Wert, ".")
    If Punkt = 1 Then Wert = "0" & Wert
    
    funPunkt = Wert
End Function

